// Multi precision toolbox for Scilab
// Copyright (C) 2009 - Jonathan Blanchard
//
// This file must be used under the terms of the CeCILL.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at
// http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt

// Input file for the gateway generation script.

toolbox_path = get_absolute_file_path('loader.sce');

functable = [ 'mpx_alloc_count',    'sci_mpx_alloc_count';
                 'mpx_memsize',        'sci_mpx_memsize';
                 'mpx_stack',          'sci_mpx_stack';
                 'mpx_donothing',      'sci_mpx_donothing';
                 'mps_format',         'sci_mps_format';
                 'mps_sformat',        'sci_mps_sformat';
                 'mps_init',           'sci_mps_init';
                 'mps_init2',          'sci_mps_init2';
                 'mps_copy',           'sci_mps_copy';
                 'mps_eye',            'sci_mps_eye';
                 'mps_ones',           'sci_mps_ones';
                 'mps_zeros',          'sci_mps_zeros';
                 'mps_const_pi',       'sci_mps_const_pi';
                 'mps_const_e',        'sci_mps_const_e';
                 'mps_const_euler',    'sci_mps_const_euler';
                 'mps_const_catalan',  'sci_mps_const_catalan';
                 'mps_const_log2',     'sci_mps_const_log2';
                 'mps_size',           'sci_mps_size';
                 'mps_prec',           'sci_mps_prec';
                 'mps_clear',          'sci_mps_clear';
                 'mps_disp',           'sci_mps_disp';
                 'mps_add',            'sci_mps_add';
                 'mps_sub',            'sci_mps_sub';
                 'mps_mul',            'sci_mps_mul';
                 'mps_div',            'sci_mps_div';
                 'mps_mat_mul',        'sci_mps_mat_mul';
                 'mps_inv',            'sci_mps_inv';
                 'mps_sin',            'sci_mps_sin';
                 'mps_cos',            'sci_mps_cos';
                 'mps_tan',            'sci_mps_tan';
                 'mps_sec',            'sci_mps_sec';
                 'mps_csc',            'sci_mps_csc';
                 'mps_cot',            'sci_mps_cot';
                 'mps_asin',           'sci_mps_asin';
                 'mps_acos',           'sci_mps_acos';
                 'mps_atan',           'sci_mps_atan';
                 'mps_sinh',           'sci_mps_sinh';
                 'mps_cosh',           'sci_mps_cosh';
                 'mps_tanh',           'sci_mps_tanh';
                 'mps_sech',           'sci_mps_sech';
                 'mps_csch',           'sci_mps_csch';
                 'mps_coth',           'sci_mps_coth';
                 'mps_asinh',          'sci_mps_asinh';
                 'mps_acosh',          'sci_mps_acosh';
                 'mps_atanh',          'sci_mps_atanh';
                 'mps_lu',             'sci_mps_lu';
                 'mps_get_ele',        'sci_mps_get_ele';
                 'mps_get_ele_seq',    'sci_mps_get_ele_seq';
                 'mps_set_ele',        'sci_mps_set_ele';
                 'mps_set_ele_seq',    'sci_mps_set_ele_seq';
                 'mps_todouble',       'sci_mps_todouble';
                 'mps_cmp_ele',        'sci_mps_cmp_ele';
                 'mps_cmp',            'sci_mps_cmp';
                 'mps_isequal',        'sci_mps_isequal';
                 'mps_isequal_margin', 'sci_mps_isequal_margin';
                 'mps_isnan',          'sci_mps_isnan';
                 'mps_isinf',          'sci_mps_isinf';
                 'mps_equal',          'sci_mps_equal';
                 'mps_lessgreater',    'sci_mps_lessgreater'
                 'mps_greater',        'sci_mps_greater';
                 'mps_greaterequal',   'sci_mps_greaterequal';
                 'mps_less',           'sci_mps_less';
                 'mps_lessequal',      'sci_mps_lessequal';
                 'mps_max',            'sci_mps_max';
                 'mps_row_max',        'sci_mps_row_max';
                 'mps_col_max',        'sci_mps_col_max';
                 'mps_maxabs',         'sci_mps_maxabs';
                 'mps_row_maxabs',     'sci_mps_row_maxabs';
                 'mps_col_maxabs',     'sci_mps_col_maxabs';
                 'mps_min',            'sci_mps_min';
                 'mps_row_min',        'sci_mps_row_min';
                 'mps_col_min',        'sci_mps_col_min';
                 'mps_minabs',         'sci_mps_minabs';
                 'mps_row_minabs',     'sci_mps_row_minabs';
                 'mps_col_minabs',     'sci_mps_col_minabs';
                 'mps_transpose',      'sci_mps_transpose';
                 'mps_neg',            'sci_mps_neg';
                 'mps_abs',            'sci_mps_abs';
                 'mps_pow',            'sci_mps_pow';
                 'mps_exp',            'sci_mps_exp';
                 'mps_exp2',           'sci_mps_exp2';
                 'mps_exp10',          'sci_mps_exp10';
                 'mps_log',            'sci_mps_log';
                 'mps_log2',           'sci_mps_log2';
                 'mps_log10',          'sci_mps_log10';
                 'mps_sqrt',           'sci_mps_sqrt';
                 'mps_coord_exg',      'sci_mps_coord_exg';
                 'mps_row_exg',        'sci_mps_row_exg';
                 'mps_row_scale',      'sci_mps_row_scale';
                 'mps_row_div',        'sci_mps_row_div';
                 'mps_row_add',        'sci_mps_row_add';
                 'mps_col_exg',        'sci_mps_col_exg';
                 'mps_col_scale',      'sci_mps_col_scale';
                 'mps_col_div',        'sci_mps_col_div';
                 'mps_col_add',        'sci_mps_col_add';
                 'mps_urandom',        'sci_mps_urandom' ];

add_help_chapter('mpscilab - Arbitrary precision toolbox for Scilab', toolbox_path + "/jar/", %F);

disp("Loading dynamic lib");

gw_lib_name = 'scimps' + getdynlibext();

// Load GMP and MPFR if found in the toolbox directory.
if(getos() == "Linux")
    [finfo,err] = fileinfo(toolbox_path + "/lib/" + "libgmp" + getdynlibext());
    if( err == 0 )
        link(toolbox_path + "/lib/" + "libgmp" + getdynlibext());
    end

    [finfo,err] = fileinfo(toolbox_path + "/lib/" + "libmpfr" + getdynlibext());
    if( err == 0 )
        link(toolbox_path + "/lib/" + "libmpfr" + getdynlibext());
    end
end

if(getos() == "Windows")
    [finfo,err] = fileinfo(toolbox_path + "\lib\" + "gmp" + getdynlibext());
    if( err == 0 )
        link(toolbox_path + "\lib\" + "gmp" + getdynlibext());
    end
    
    [finfo,err] = fileinfo(toolbox_path + "\lib\" + "mpir" + getdynlibext());
    if( err == 0 )
        link(toolbox_path + "\lib\" + "mpir" + getdynlibext());
    end

    [finfo,err] = fileinfo(toolbox_path + "\lib\" + "mpfr" + getdynlibext());
    if( err == 0 )
        link(toolbox_path + "\lib\" + "mpfr" + getdynlibext());
    end
end

addinter(toolbox_path + '/lib/' + gw_lib_name, 'scimps', functable(:,1));

// Register the interface to handle arguments by reference.

intppty( floor(funptr( "mps_add" ) / 1000) );

// Load the compiled macros.
mpscilablib = lib( toolbox_path+'macros' );


