// Multi precision toolbox for Scilab
// Copyright (C) 2011 - Jonathan Blanchard

// This file must be used under the terms of the CeCILL.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at
// http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt

// <-- JVM NOT MANDATORY -->

// Tests for the overloaded extraction (B=A(n1,n2)).

A = [ 1  2  3  4  5  6;
      7  8  9  10 11 12;
      13 14 15 16 17 18;
      19 20 21 22 23 24 ];

mpsA = mps_init2(A, 100);

mpsB = mpsA(1);
B = A(1);
rst = mps_isequal(mpsB, B);
if rst <> %t  then pause, end
rst = %f;

mpsB = mpsA(2);
B = A(2);
rst = mps_isequal(mpsB, B);
if rst <> %t  then pause, end
rst = %f;

mpsB = mpsA(7);
B = A(7);
rst = mps_isequal(mpsB, B);
if rst <> %t  then pause, end
rst = %f;

mpsB = mpsA(24);
B = A(24);
rst = mps_isequal(mpsB, B);
if rst <> %t  then pause, end
rst = %f;

mpsB = mpsA([1 2 4 2]);
B = A([1 2 4 2]);
rst = mps_isequal(mpsB, B);
if rst <> %t  then pause, end
rst = %f;

mpsB = mpsA([1 2; 4 2]);
B = A([1 2; 4 2]);
rst = mps_isequal(mpsB, B);
if rst <> %t  then pause, end
rst = %f;

mpsB = mpsA(1,1);
B = A(1,1);
rst = mps_isequal(mpsB, B);
if rst <> %t  then pause, end
rst = %f;

mpsB = mpsA(1,2);
B = A(1,2);
rst = mps_isequal(mpsB, B);
if rst <> %t  then pause, end
rst = %f;

mpsB = mpsA(2,2);
B = A(2,2);
rst = mps_isequal(mpsB, B);
if rst <> %t  then pause, end
rst = %f;

mpsB = mpsA(4,6);
B = A(4,6);
rst = mps_isequal(mpsB, B);
if rst <> %t  then pause, end
rst = %f;

mpsB = mpsA([1 2 3],[3 2 1]);
B = A([1 2 3],[3 2 1]);
rst = mps_isequal(mpsB, B);
if rst <> %t  then pause, end
rst = %f;

mpsB = mpsA([1 2; 3 4],[3 2 1]);
B = A([1 2; 3 4],[3 2 1]);
rst = mps_isequal(mpsB, B);
if rst <> %t  then pause, end
rst = %f;

mpsB = mpsA([1 2; 3 4],[3 2; 1 4]);
B = A([1 2; 3 4],[3 2; 1 4]);
rst = mps_isequal(mpsB, B);
if rst <> %t  then pause, end
rst = %f;